package com.xunmei.system.mapper;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xunmei.system.api.domain.SysWorkTime;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.xunmei.system.dto.SysWorkTimeDto;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

/**
 * 【请填写功能名称】Mapper接口
 *
 * @author xunmei
 * @date 2023-08-14
 */
public interface SysWorkTimeMapper extends BaseMapper<SysWorkTime> {
    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
     SysWorkTime selectSysWorkTimeById(String id);

    List<SysWorkTime> findByOrgAndMonth(SysWorkTime request);

    /**
     * 根据机构获取 当前月的数据
     * @param orgId
     * @param start
     * @param end
     * @return
     */
    List<SysWorkTime> findByOrgAndDate(@Param("orgId")Long orgId,@Param("start") Date start,@Param("end") Date end);

    List<SysWorkTime> findByYmd(@Param("orgIds") List<Long> orgIds, @Param("date") String date);

    List<SysWorkTime> getOrgWorkTimeByMonth(@Param("map") Map<String, Object> map);

    List<Long> findOrgIdsByYmd(@Param("date") String date);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param sysWorkTime 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
     List<SysWorkTime> selectSysWorkTimeList(SysWorkTime sysWorkTime);
    @MapKey("id")
     IPage<SysWorkTimeDto> selectByPage(Page<SysWorkTime> page, @Param(Constants.WRAPPER) Wrapper<SysWorkTime> queryWrapper);

    /**
     * 新增【请填写功能名称】
     *
     * @param sysWorkTime 【请填写功能名称】
     * @return 结果
     */
     int insertSysWorkTime(SysWorkTime sysWorkTime);

    /**
     * 修改【请填写功能名称】
     *
     * @param sysWorkTime 【请填写功能名称】
     * @return 结果
     */
     int updateSysWorkTime(SysWorkTime sysWorkTime);

    /**
     * 删除【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
     int deleteSysWorkTimeById(String id);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
     int deleteSysWorkTimeByIds(String[] ids);
}
